#!/usr/bin/env python
# coding: utf-8

# In[ ]:


import os
import sys
import jieba.posseg as pseg
import jieba
import jieba.analyse
import warnings
warnings.filterwarnings(action='ignore',category=UserWarning,module='gensim')
from gensim import corpora,models,similarities
from collections import defaultdict
import numpy as np
import pandas as pd
from  wordcloud import WordCloud
import matplotlib.pyplot as plt
from timeit import Timer
import xlwt

def similarities_calculation(standad_text_rootdir1,stop_words_rootdir2,standards_words_dictionary_rootdir3,text_similarities_exce_rootdir4 ):
    stop_flag = ['x', 'c', 'u', 'd', 'p', 't', 'uj', 'm', 'f', 'r','un','w','y','a','eng'] 
    stop_words=open(stop_words_rootdir2,encoding='gb18030',errors='ignore').read()
    root_list1=os.listdir(standad_text_rootdir1)
    rootines=[]
    for i in root_list1:
        rootines.append(os.path.join(standad_text_rootdir1,i)) 
    assert len(rootines)==len(root_list1)
    words_list=[]
    for root in rootines:
        words1=open(root,encoding='gb18030',errors='ignore').read()
        words2=pseg.cut(words1)
        words_list1=[]
        words_list4=[]
        words_list5=[]
        for words,flag in words2:
            if words not in stop_words and flag not in stop_flag:
                if(len(words)>=2):
                    words_list1.append(words)
                else:
                    pass
            else:
                continue
        words_str=''.join(words_list1)
        words_list3=jieba.analyse.textrank(words_str, topK=40, withWeight=True)
        for i in words_list1:
            for j in words_list3:
                if i==j[0]:
                    words_list5.append(i)
                else:
                    continue
        words_list.append(words_list5)  
    dictionary=corpora.Dictionary(words_list) 
    with open (standards_words_dictionary_rootdir3,'w') as dct:  #Save the dictionary as a document so that you can see which words need to be added directly to stop_words_rootdir2 later
        for i in dictionary:
            dct.write(str(dictionary[i]))
            dct.write('\n')
    num_features = len(dictionary.token2id)
    corpus = [dictionary.doc2bow(text) for text in words_list]
    tfidf = models.TfidfModel(corpus)
    index = similarities.SparseMatrixSimilarity(tfidf[corpus], num_features)
    book=xlwt.Workbook(encoding='utf-8')
    sheet=book.add_sheet('quanzhongshuju')
    mm=0
    for root in rootines:
        words6=open(root,encoding='gb18030',errors='ignore').read()
        words7=pseg.cut(words6)
        words_list6=[]
        for words,flag in words7:
            if words not in stop_words and flag not in stop_flag:
                if(len(words)>=2):
                    words_list6.append(words)
                else:
                    pass
            else:
                continue
        new_vec = dictionary.doc2bow(words_list6)
        sim = index[tfidf[new_vec]]
        sim11=np.array(sim,dtype=np.float64)
        for i in range(len(sim)):
            print('与第%d个文档的相似度为%f'%(i+1,sim11[i]))
            sheet.write(mm,i,sim11[i])
        mm+=1
    book.save(text_similarities_exce_rootdir4 )
    
class PRIterator:
    damping_factor=0.5
    
    max_iterations = 100
    min_delta = 0.00001
    def __init__(self,dg1):
        self.graph = dg1
    def page_rankss(self):
        similarities_root="D:/Desktop/重要材料/论文准备工作/new_similarity.xls"   #text_similarities_exce_rootdir4 above
        Workbook = xlrd.open_workbook(similarities_root)
        mySheet=Workbook.sheet_by_name('quanzhongshuju')
        first_col=mySheet.col_values(0)
        #print(len(self.graph.nodes))
        #print(self.graph.nodes)
        for node1 in list(self.graph.nodes):
            if len(list(self.graph.successors(node1)))==0:
                for node2 in list(self.graph.nodes):
                    self.graph.add_edge(node1,node2)
        #print(len(self.graph.edges))
        nodes=list(self.graph.nodes)
        new_nodes=[]
        for i in nodes:
            new_nodes.append(int(i))
        graph_size = len(nodes)
        if graph_size == 0:
            return 'haha,it is funning'
        else:
            pass
        page_rank = dict.fromkeys(new_nodes, 1 / graph_size)
        damping_value = (1 - self.damping_factor) / graph_size
        for i in range(self.max_iterations):
            
            changes=[]
            change_number=0
            for node in nodes:
                rank=0
                if len(list(self.graph.successors(node)))==0:
                    print("it is a mistake ,check")
                else:
                    in_node=[]
                    for k in list(self.graph.edges):
                        if k[1]==node:
                            in_node.append(k[0])
                    for m in in_node:
                        similarities={}
                        if m in list(self.graph.successors(m)):
                            for j in new_nodes:
                                if int(m)!=j:
                                    similarities[j]=mySheet.cell(first_col.index(int(m)),first_col.index(j)).value
                            similarities_valuess=[]
                            for d in similarities:
                                similarities_valuess.append(similarities[d])
                            similarities[int(m)]=min(similarities_valuess)/100
                            sum_similarities=0
                            for out_node in list(self.graph.successors(m)):
                                sum_similarities+=similarities[int(out_node)]
                            #print(sum_similarities)
                            if sum_similarities==0:
                                rank+=self.damping_factor*(page_rank[int(m)])/len(list(self.graph.successors(m)))
                            else:
                            
                                rank+=self.damping_factor*(similarities[int(node)]/sum_similarities)*page_rank[int(m)]
                        else:
                            
                            for jj in new_nodes:
                                if int(m)!=jj:
                                    similarities[jj]=mySheet.cell(first_col.index(int(m)),first_col.index(jj)).value

                            sum_similarities=0
                            for out_node1 in list(self.graph.successors(m)):
                                sum_similarities+=similarities[int(out_node1)]
                                
                            if sum_similarities==0:
                                rank+=self.damping_factor*(page_rank[int(m)])/len(list(self.graph.successors(m)))
                            else:
                                rank+=self.damping_factor*(similarities[int(node)]/sum_similarities)*page_rank[int(m)]
                            
                    
                    rank += damping_value
                    changes.append(abs(page_rank[int(node)] - rank))
                    page_rank[int(node)] = rank
            
                    
            print("This is NO.%d iteration" % (i+1))
            print(page_rank)
            for i in changes:
                if i <self.min_delta:
                    change_number+=1

            if change_number==len(nodes):
                final=True
                break
            else:
                continue
        if final:
            print("finished")
            workbook = xlwt.Workbook(encoding='utf-8')
            sheet = workbook.add_sheet('pageranks')
            m=0
            for i in page_rank:
                sheet.write(m,0,i)
                sheet.write(m,1,page_rank[i])
                m+=1
            workbook.save('new_pagerank_value_rank_ddd.xls')  #
            return page_rank
        else:
            print("out of max_iteratuons 100")

if __name__ == "__main__":
    dg = nx.DiGraph()
    with open ("D:/Desktop/重要材料/论文准备工作/number-edge.txt",'r' ) as f:   #the path of the edge data of your network
        edges_text=f.readlines()
    edges=[]
    for edge in edges_text:
        j=edge.split(' ')
        k=[j[0],j[1].replace('\n','')]
        edges.append(k)
    nodes=[]
    for edge in edges:
        if edge[0] not in nodes:
            nodes.append(edge[0])
        if edge[1] not in nodes:
            nodes.append(edge[1])
    for edge in edges:
        dg.add_edge(edge[0],edge[1])
    #pos=nx.circular_layout(dg)
    #tu=nx.draw(dg,pos,node_color=range(len(nodes)), node_size=80, cmap=plt.cm.Reds,with_labels =True,width=0.3)
    #plt.savefig('picture1.png')
    #plt.show()
    test=PRIterator(dg)
    test.page_rankss()

